
#include "atmega_bmp085_lib.h"
#include "uart.h"

long int res_pressure = 0;
int32_t temperature = 0;
int32_t pressure = 0;
int16_t BMP085_calibration_int16_t[8];
int16_t BMP085_calibration_uint16_t[3];
uint8_t error_code=0;

long int temp_bmp;

long int BMP(void)
{	


	_delay_ms(11);
	i2cSetBitrate(1000);		//Initialize TWI 1000kHz	
	BMP085_Calibration(BMP085_calibration_int16_t, BMP085_calibration_uint16_t,&error_code);////Initialize BMP085
//-----------------------------------------
// Do forever
//-----------------------------------------

		bmp085Convert(BMP085_calibration_int16_t, BMP085_calibration_uint16_t,&temperature, &pressure,&error_code);

		
//		int altitude = bmp085CalcAltitude(pressure);

		absolute_pressure(pressure,(temperature/10), 26);		// altitude =26NN (mittlere Hhe von Wesel)
		temp_bmp = temperature;
	return 0;
}



void absolute_pressure(long int rel_pressure,long int temp_BMP085,int altitude_NN)
{
//	char buffer[50];
	
	const float g0 = 9.80665;							// m/s
	const float R_air = 287.05; 						// m/(sK)
	const float a = 0.0065; 							// K/m
	float temp = 273.15 + temp_BMP085;					// K

	float E;
	E = 6.112 * exp((17.62*20)/(243.12+20));

/*	if (temp_BMP085 < 9)
	E = 5.6402 * (-0.0916 + exp(0.06 * temp_BMP085));
	else
	E = 18.2194 * (1.0436 - exp((-0.0666) * temp_BMP085));
*/	
	const float Ch = 0.12; //K/hPa

	float x = g0 / ((R_air * temp) + (Ch * E) + (a * (altitude_NN/2)));

	res_pressure = rel_pressure * exp(x);
	res_pressure /= 100;
//	sprintf(buffer, "Luftdruck auf Meereshoehe reduziert: %ld \r\n", res_pressure);
//	uart_puts(buffer);
}

