#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
//#define F_CPU 8000000UL



// lange, variable Wartezeit, Einheit in Millisekunden

void long_delay(uint16_t ms) {
    for (; ms>0; ms--) _delay_ms(1);
}

// Timer2 konfigurieren
void init_timer2()
{
    ASSR  = (1<< AS2);           								    // Timer2 asynchron takten
    long_delay(1000);               								// Einschwingzeit des 32kHz Quarzes
	TCCR2  |= (1<<CS21) | (1<<CS22);								// Vorteiler 256 -> 2s berlaufperiode			                   
    while((ASSR & (1<< TCR2UB)));								    // Warte auf das Ende des Zugriffs
    TIFR   = (1<<TOV2);             								// Interrupts lschen (*)
    TIMSK |= (1<<TOIE2);
	TCNT2 = 0;             								// Timer overflow Interrupt freischalten
// (*) "Alternatively, TOV2 is cleared by writing a logic one to the flag."
}

